# -*- coding: utf8 -*-
# author: Ludwig Reiter


from sqlalchemy import event
from euhu.esf import to_esf
from euhu.programs.sib import to_bmas, validate
from efa.model.participant import Participant, \
    generate_determine_reportable_function, listener_adapter
from ringo_bmasreport.reports.durchfuehrungsbericht import (
    indicators, recipe
)


program = "sib"
indicators['RI'].append(('A2.1', u'Teilnehmerinnen, die nach ihrer Teilnahme einen Arbeitsplatz haben, auf Arbeitsuche sind oder für den Arbeitsmarkt aktiviert wurden (A2.1)'))
indicators['OI'].append(('PO02', u'Anzahl Frauen, die im Rahmen des Vorhabens gefördert werden. (PO02)'))


def derive_indicators(values):
    return to_esf(to_bmas(values)).esf


td_update_listener = listener_adapter(
    generate_determine_reportable_function(derive_indicators,
                                           recipe,
                                           validate,
                                           program))


event.listen(Participant, 'after_update', td_update_listener)
