import sqlalchemy as sa
from efa.model.resultindicators import ResultIndicators
from formbar.form import Form
from ringo.model import Base
from ringo.lib.form import get_form_config


# Many-to-many intermediate tables for industry questions in OI form
#nm_ri_industry = sa.Table(
#    'nm_ri_industries',
#    Base.metadata,
#    sa.Column('ri_id', sa.Integer, sa.ForeignKey('resultindicators.id')),
#    sa.Column('industry_id', sa.Integer, sa.ForeignKey('sib_ri_industry.id'))
#)
#
#
#nm_ri_industry_wish = sa.Table(
#    'nm_ri_industries_wish',
#    Base.metadata,
#    sa.Column('ri_id', sa.Integer, sa.ForeignKey('resultindicators.id')),
#    sa.Column('industry_id', sa.Integer, sa.ForeignKey('sib_ri_industry.id'))
#)

'''
class PweRiIndustry(Base):
    """SIB specific Resultindicators. Adds some local fields.
    """
    __tablename__ = 'sib_ri_industry'

    # Status of the outputindicators
    id = sa.Column(sa.Integer, primary_key=True)
    value = sa.Column('value', sa.String)

    def __str__(self):
        return self.value
'''
    
class SIBResultIndicators(ResultIndicators):
    participation = sa.orm.relation(
        "Participation",
        enable_typechecks=False,
        backref=sa.orm.backref("sibri",
                                uselist=False,
                                cascade="all"))

    qualification_integration_class = sa.Column('qualification_integration_class', sa.Integer)
    qualification_language_course = sa.Column('qualification_language_course', sa.Integer)
    qualification_other_language_course = sa.Column('qualification_other_language_course', sa.Integer)
    qualification_edv = sa.Column('qualification_edv', sa.Integer)
    qualification_tagespflegeperson = sa.Column('qualification_tagespflegeperson', sa.Integer)
    qualification_integrationslotsin = sa.Column('qualification_integrationslotsin', sa.Integer)
    qualification_misc = sa.Column('qualification_misc', sa.Integer)
    qualification_misc_text = sa.Column('qualification_misc_text', sa.Text, nullable=False, server_default='')
    change_to_si = sa.Column('change_to_si', sa.Integer)
    success_voluntary = sa.Column('success_voluntary', sa.Integer)
    success_support_group = sa.Column('success_support_group', sa.Integer)
    success_internship = sa.Column('success_internship', sa.Integer)
    success_school_job_degree = sa.Column('success_school_job_degree', sa.Integer)
    success_misc = sa.Column('success_misc', sa.Integer)
    success_misc_text = sa.Column('success_misc_text', sa.Text, nullable=False, server_default='')
    project_module = sa.Column('project_module', sa.String, default='')
    project_module_additional = sa.Column('project_module_additional',
            sa.String)
    project_module_additional_other = sa.Column(
            'project_module_additional_other', sa.String, nullable=True,
            default='')

    # FP2
    reason_early_exit = sa.Column('reason_early_exit', sa.Integer)
    new_employment_mode = sa.Column('new_employment_mode', sa.Integer)
    new_employment_volume = sa.Column('new_employment_volume', sa.Integer)
    new_employment_permanent = sa.Column('new_employment_permanent',
                                         sa.Integer)
    new_employment_industry_fp2 = sa.Column('new_employment_industry_fp2',
                                            sa.Integer)
    new_employment_industry_fp2_erzieherin = sa.Column(
        'new_employment_industry_fp2_erzieherin', sa.Integer)
    new_employment_industry_fp2_nurse = sa.Column(
        'new_employment_industry_fp2_nurse', sa.Integer)
    success_school_graduation = sa.Column('success_school_graduation',
                                          sa.Integer)
    success_job_qualification = sa.Column('success_job_qualification',
                                          sa.Integer)
    project_module_fp2 = sa.Column('project_module_fp2', sa.String,
                                     default='')
    project_module_fp2_other = sa.Column('project_module_fp2_other',
                                         sa.String, nullable=True,
                                         default='')
